



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何解决Android帧动画出现的内存溢出</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何解决Android帧动画出现的内存溢出</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 12:06:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这几天在做动画的时候，遇到了一个OOM的问题，特此记录下来。</p>
<h3>普通实现</h3>
<p>实现一个帧动画，最先想到的就是用animation-list将全部图片按顺序放入，并设置时间间隔和播放模式。然后将该drawable设置给ImageView或Progressbar就OK了。</p>
<pre class="prettyprint linenums"><code>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;<br />
&lt;animation-list xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;<br />
                android:oneshot=&quot;false&quot;&gt;

    &lt;item android:drawable=&quot;@drawable/smile0&quot; android:duration=&quot;30&quot;/&gt;<br />
    &lt;item android:drawable=&quot;@drawable/smile1&quot; android:duration=&quot;30&quot;/&gt;<br />
    &lt;item android:drawable=&quot;@drawable/smile2&quot; android:duration=&quot;30&quot;/&gt;<br />
    &lt;item android:drawable=&quot;@drawable/smile3&quot; android:duration=&quot;30&quot;/&gt;<br />
    &lt;item android:drawable=&quot;@drawable/smile4&quot; android:duration=&quot;30&quot;/&gt;<br />
&lt;/animation-list&gt;<br />
</code></pre>
<p>但是如果图片太多了，而且每张图片几百K的情况，就会出现OOM的问题。可以参考Stack Overflow上的这个问题<a href="https://stackoverflow.com/questions/8692328/causing-outofmemoryerror-in-frame-by-frame-animation-in-android" rel="external nofollow noreferrer">Causing OutOfMemoryError in Frame by Frame Animation in Android</a>。</p>
<p>造成OOM的原因是因为帧动画从xml中读取图片的时候，一次性读取了所有的图片，并设置给ImageView，所以在图片数量过多和图片过大的时候，就会出现OOM。既然知道了原因，那么解决思路也很简单，就是在进行帧动画显示的时候，不要一下子读取所有的图片，而是需要谁就读取谁。</p>
<p>在github上找到一个例子，<a href="https://github.com/tigerjj/FasterAnimationsContainer" rel="external nofollow noreferrer">tigerjj/FasterAnimationsContainer</a>，具体实现代码如下</p>
<pre class="prettyprint linenums"><code>public class FasterAnimationsContainer {<br />
	private class AnimationFrame{<br />
		private int mResourceId;<br />
		private int mDuration;<br />
		AnimationFrame(int resourceId, int duration){<br />
			mResourceId = resourceId;<br />
			mDuration = duration;<br />
		}<br />
		public int getResourceId() {<br />
			return mResourceId;<br />
		}<br />
		public int getDuration() {<br />
			return mDuration;<br />
		}<br />
	}<br />
	private ArrayList&lt;AnimationFrame&gt; mAnimationFrames; // list for all frames of animation<br />
	private int mIndex; // index of current frame

	private boolean mShouldRun; // true if the animation should continue running. Used to stop the animation<br />
	private boolean mIsRunning; // true if the animation prevents starting the animation twice<br />
	private SoftReference&lt;ImageView&gt; mSoftReferenceImageView; // Used to prevent holding ImageView when it should be dead.<br />
	private Handler mHandler; // Handler to communication with UIThread

	private Bitmap mRecycleBitmap;  //Bitmap can recycle by inBitmap is SDK Version &gt;=11

	// Listeners<br />
	private OnAnimationStoppedListener mOnAnimationStoppedListener;<br />
	private OnAnimationFrameChangedListener mOnAnimationFrameChangedListener;

	private FasterAnimationsContainer(ImageView imageView, Context mContext) {<br />
		this.mContext = mContext;<br />
		init(imageView, mContext);<br />
	};

	// single instance procedures<br />
	private static FasterAnimationsContainer sInstance;

	private Context mContext;

	public static FasterAnimationsContainer getInstance(ImageView imageView, Context mContext) {<br />
		if (sInstance == null)<br />
			sInstance = new FasterAnimationsContainer(imageView, mContext);<br />
		sInstance.mRecycleBitmap = null;<br />
		return sInstance;<br />
	}

	/**<br />
	 * initialize imageview and frames<br />
	 * @param imageView<br />
	 * @param mContext<br />
	 */<br />
	public void init(ImageView imageView, Context mContext){<br />
		mAnimationFrames = new ArrayList&lt;AnimationFrame&gt;();<br />
		mSoftReferenceImageView = new SoftReference&lt;ImageView&gt;(imageView);

		mHandler = new Handler();<br />
		if(mIsRunning == true){<br />
			stop();<br />
		}

		mShouldRun = false;<br />
		mIsRunning = false;

		mIndex = -1;<br />
	}

	/**<br />
	 * add a frame of animation<br />
	 * @param index index of animation<br />
	 * @param resId resource id of drawable<br />
	 * @param interval milliseconds<br />
	 */<br />
	public void addFrame(int index, int resId, int interval){<br />
		mAnimationFrames.add(index, new AnimationFrame(resId, interval));<br />
	}

	/**<br />
	 * add a frame of animation<br />
	 * @param resId resource id of drawable<br />
	 * @param interval milliseconds<br />
	 */<br />
	public void addFrame(int resId, int interval){<br />
		mAnimationFrames.add(new AnimationFrame(resId, interval));<br />
	}

	/**<br />
	 * add all frames of animation<br />
	 * @param resId resource id of drawable<br />
	 * @param interval milliseconds<br />
	 */<br />
	public void addAllFrames(int resId, int interval){<br />
		int[] drawableIds = getData(resId);<br />
		for(int drawableId : drawableIds){<br />
			mAnimationFrames.add(new AnimationFrame(drawableId, interval));<br />
		}<br />
	}

	/**<br />
	 * 从xml中读取帧数组<br />
	 * @param resId<br />
	 * @return<br />
	 */<br />
	private int[] getData(int resId){<br />
		TypedArray array = mContext.getResources().obtainTypedArray(resId);

		int len = array.length();<br />
		int[] intArray = new int[array.length()];

		for(int i = 0; i &lt; len; i++){<br />
			intArray[i] = array.getResourceId(i, 0);<br />
		}<br />
		array.recycle();<br />
		return intArray;<br />
	}

	/**<br />
	 * remove a frame with index<br />
	 * @param index index of animation<br />
	 */<br />
	public void removeFrame(int index){<br />
		mAnimationFrames.remove(index);<br />
	}

	/**<br />
	 * clear all frames<br />
	 */<br />
	public void removeAllFrames(){<br />
		mAnimationFrames.clear();<br />
	}

	/**<br />
	 * change a frame of animation<br />
	 * @param index index of animation<br />
	 * @param resId resource id of drawable<br />
	 * @param interval milliseconds<br />
	 */<br />
	public void replaceFrame(int index, int resId, int interval){<br />
		mAnimationFrames.set(index, new AnimationFrame(resId, interval));<br />
	}

	private AnimationFrame getNext() {<br />
		mIndex++;<br />
		if (mIndex &gt;= mAnimationFrames.size())<br />
			mIndex = 0;<br />
		return mAnimationFrames.get(mIndex);<br />
	}

	/**<br />
	 * Listener of animation to detect stopped<br />
	 *<br />
	 */<br />
	public interface OnAnimationStoppedListener{<br />
		public void onAnimationStopped();<br />
	}

	/**<br />
	 * Listener of animation to get index<br />
	 *<br />
	 */<br />
	public interface OnAnimationFrameChangedListener{<br />
		public void onAnimationFrameChanged(int index);<br />
	}

	/**<br />
	 * set a listener for OnAnimationStoppedListener<br />
	 * @param listener OnAnimationStoppedListener<br />
	 */<br />
	public void setOnAnimationStoppedListener(OnAnimationStoppedListener listener){<br />
		mOnAnimationStoppedListener = listener;<br />
	}

	/**<br />
	 * set a listener for OnAnimationFrameChangedListener<br />
	 * @param listener OnAnimationFrameChangedListener<br />
	 */<br />
	public void setOnAnimationFrameChangedListener(OnAnimationFrameChangedListener listener){<br />
		mOnAnimationFrameChangedListener = listener;<br />
	}

	/**<br />
	 * Starts the animation<br />
	 */<br />
	public synchronized void start() {<br />
		mShouldRun = true;<br />
		if (mIsRunning)<br />
			return;<br />
		mHandler.post(new FramesSequenceAnimation());<br />
	}

	/**<br />
	 * Stops the animation<br />
	 */<br />
	public synchronized void stop() {<br />
		mShouldRun = false;<br />
	}

	private class FramesSequenceAnimation implements Runnable{

		@Override<br />
		public void run() {<br />
			ImageView imageView = mSoftReferenceImageView.get();<br />
			if (!mShouldRun || imageView == null) {<br />
				mIsRunning = false;<br />
				if (mOnAnimationStoppedListener != null) {<br />
					mOnAnimationStoppedListener.onAnimationStopped();<br />
				}<br />
				return;<br />
			}<br />
			mIsRunning = true;

			if (imageView.isShown()) {<br />
				AnimationFrame frame = getNext();<br />
				GetImageDrawableTask task = new GetImageDrawableTask(imageView);<br />
				task.execute(frame.getResourceId());<br />
				// TODO postDelayed after onPostExecute<br />
				mHandler.postDelayed(this, frame.getDuration());<br />
			}<br />
		}<br />
	}

	private class GetImageDrawableTask extends AsyncTask&lt;Integer, Void, Drawable&gt; {

		private ImageView mImageView;

		public GetImageDrawableTask(ImageView imageView) {<br />
			mImageView = imageView;<br />
		}

		@SuppressLint(&quot;NewApi&quot;)<br />
		@Override<br />
		protected Drawable doInBackground(Integer... params) {<br />
			if(Build.VERSION.SDK_INT &lt; Build.VERSION_CODES.HONEYCOMB){<br />
				return mContext.getResources().getDrawable(params[0]);<br />
			}<br />
			BitmapFactory.Options options = new BitmapFactory.Options();<br />
			options.inMutable = true;<br />
			if (mRecycleBitmap != null)<br />
				options.inBitmap = mRecycleBitmap;<br />
			mRecycleBitmap = BitmapFactory.decodeResource(mContext.getResources(), params[0], options);<br />
			BitmapDrawable drawable = new BitmapDrawable(mContext.getResources(),mRecycleBitmap);<br />
			return drawable;<br />
		}

		@Override<br />
		protected void onPostExecute(Drawable result) {<br />
			super.onPostExecute(result);<br />
			if(result!=null) mImageView.setImageDrawable(result);<br />
			if (mOnAnimationFrameChangedListener != null)<br />
				mOnAnimationFrameChangedListener.onAnimationFrameChanged(mIndex);<br />
		}

	}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2j22w8.html">iOS开发CoreGraphics核心图形框架之一&mdash;&mdash;CGPath的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxjdjq.html">Linq专题之创建Linq查询表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3r409.html">初探Asp&period;net5</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ewk59.html">【HTTP协议】响应头中的Content-Length和Transfer-Encoding</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mznrkq.html">BZOJ 1690 奶牛的旅行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn26pd8.html">map与set的遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7gx39.html">C&num;下载http文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04gleq.html">Android MVP框架模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x222m8.html">把Go程序变小的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mee248.html">H5微信播放全屏问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwn5e8.html">js函数的作用域与this指向</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxodz9.html">Spring配置优化&lowbar;构造器注入&plus;自动装配</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ww21q.html">开源IMDG之GridGain</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmnvz8.html">【Angular 5】数据绑定、事件绑定和双向绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1nrl1q.html">开发部署项目时出现：java&period;lang&period;OutOfMemoryError&colon; PermGen space</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjm4o79.html">Feign get接口传输对象引发一场追寻</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllj0ekq.html">Taro 列表循环--点赞功能图片切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyv2x39.html">未能写入输出文件&OpenCurlyDoubleQuote;c&colon;&bsol;Windows&bsol;Microsoft&period;NET&bsol;Framework64&bsol;v4&period;0&period;30319&bsol;Temporary ASP&period;NET Files&bsol;root&bsol;2da42acc&bsol;ab2935</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gn05eq.html">关于springmvc json交互产生的406错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyzpen9.html">web中集成shiro</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv24z2o9.html">sass之为什么要使用预处理器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25p0w3q.html">Python类方法、静态方法与实例方法  -----类里面不需要实例化参数 和没带self的函数  调用此函数的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy0jlv9.html">数据库SQL语言学习--上机练习4（视图）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g2j2eq.html">学习笔记之NumPy</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvp53j8.html">【转】XP&lowbar;cmdshell存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd76wv9.html">&lbrack;UE4&rsqb;打包EXE</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ok22x8.html">https证书的验证过程与生成方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4z37j9.html">vue vue-resource 请求数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy0ed39.html">&lbrack;SQL&rsqb;注释</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m21zypq.html">tips：Java中的switch的选择因子</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
